/* Fundamentos da computacao 2
   Anderson Koyama Vieira 6451050

   Projeto Final - SUPER RACE
   Descricao: jogo no qual o objetivo e´ desviar dos carros que vao de encontro ao
              carro que o jogador controla. E´ possivel movimentar o carro para a esquerda de direita
              utilizando as setas do teclado; e quando a barra Slow Motion esta´ cheia, pode-se apertar
              o botao 's' para que entre no modo lento.
*/


////======================DECLARACAO DE VARIAVEIS=============================
//  essas declaracoes de variáveis precisam estar fora das funcoes SETUP e DRAW
//  para que sejam globais, mantendo seus conteudos quando as funcoes
//  encerram a execucao
 
 
// variaveis do tipo PImage que armazenam imagens
PImage car;
PImage carmask;
PImage opp;
PImage oppmask;

// variavel do tipo PFonto que armazena uma fonte
PFont font;

// coordenadas do carro do jogador
int px=40;
int py=355;

// largura da barra de slow motion
int slowBar;

// relacionada com a barra de slowmotion
int ready;

// controla o rastro dos carros quando no modo slowmotion
int alfa;

// exibe a cor verde na barra de slowmotion
int colorGreen;

// incremento vertical dos oponentes
int incY;

// número de vidas do jogador; ou numero de vezes que o jogador
// pode bater antes de dar game over
int vida;

// controla o numero de frames do programa, isso faz
// com que a velocidade dos oponentes mude
int frame;

// numero de voltas do oponente
// uma volta corresponde a descida do oponente ate o final inferior da tela
int voltas;

// exibe fase em que o jogador se encontra
int level;

// condicao para ativar ou desativar as setas do teclado
int p;

// vetor das coordenadas dos oponentes, ao total sao 2 oponentes
int []pox =new int[2];
int []poy= new int[2];

// O boolean foi utilizado para separar as varias sessoes do jogo

// mostra a tela de entrada
boolean inicio;
// aqui ocorre o jogo em si 
boolean jogo;
// tela de game over
boolean gameOver;
// tela mostrada quando o jogador bate o carro, mas vai para a tela de game over
boolean crash;
// modo slow motion
boolean slowMotion;

//======================FUNCAO DESENHA FUNDO=============================
// funcao que desenha o background da sessao boolean jogo
void desenhaFundo(){
  // desenha o retangulo azul de cor 43,57,144 sem borda
  // e de modo CORNER: desenhado pelo canto superior esquerdo
  fill(43,57,144);
  rectMode(CORNER);
  rect(181,0,131,400);
  
  // desenha as faixas brancas e os retangulos que exibem
  // a vida e o nivel
  fill(245); //cor branca
  rect(0,0,10,400);
  rect(181,0,10,400);
  rect(200,50,50,20);
  rect(200,140,50,20);
  fill(0); //cor preta
  rect(202,52,46,16);
  rect(202,142,46,16);
  
  // desenha os texto "life" e "level" na lateral direita e seus respectivos valores
  textFont(font,12);
  fill(0);
  text("level",202,137);
  text("life",202,47);
  fill(245);
  text("life",200,45);
  text("level",200,135); 
  text(vida,205,65);
  text(level,205,155);
  
  //desenha retangulo preto que atualiza as posicoes de todos os carros
  fill(0,alfa); //o alpha muda quando o modo slow motion esta´ ativo
  rectMode(CORNER);
  rect(10,0,171,400);  
}

//======================FUNCAO DESENHA CARRO=============================
//funcao que desenha o carro do jogador
void desenhaCarro(){
  // desenha um retangulo transparente, na mesma posicao da iagem do carro que serve para fazer o calculo
  // da distancia com o carro do oponente
  fill(0,0);
  rectMode(CENTER);
  rect(px,py,55,90);
  
  // exibe a imagem "car" do carro do jogador
  image(car,px-27,py-45);
}

//======================FUNCAO DESENHA SLOWBAR=============================
// funcao que desenha a barra de slow motion
void desenhaSlowBar(){
  
  // desenha o retangulo preto de bordas brancas que exibem a barra de slowmotion
  rectMode(CORNER);
  fill(245);
  rect(200,300,100,20);
  fill(0);
  rect(202,302,96,16);
  
  // desenha o texto "SLOW MOTION" na lateral
  textFont(font,12);
  text("slow motion",202,297);
  fill(200,colorGreen,0);
  rect(204,304,slowBar,12);
  fill(255);
  text("slow motion",200,295);
}

//======================FUNCAO KEY PRESSED=============================
// funcao que controla as setas do teclado para mover o carro do jogador
void keyPressed() {
  // se a condicao p for igual a 1, entao os comandos do teclado sao liberados
  if (p==1){
    switch(keyCode){
      case LEFT: // quando a seta para esquerda e´ apertada, satisfazendo a condicao de nao passar da borda, o carro anda para a esquerda
        if (px > 56)px -= 55;
          break;
      case RIGHT: // quando a seta para a direita e´ apertada, satisfazendo a condicao de nao passar da borda, o carro anda para a direita
        if (px < 100)px += 55;
          break;
    } 
  }
}

//======================FUNCAO DESENHA OPONENTE=============================
// desenha os carros oponentes
void desenhaOponente(){
  
  
  for (int i = 0; i < 2; i++) {
    //desenha retangulos transparentes, na mesma posicao da imagem do carro, para fazer o calculo da distancia com o carro do jogador
    rectMode(CENTER);
    fill(0,0);
    rect(pox[i],poy[i],55,90);
    
    // exibe a imagem "opp" do carro do oponente na mesma posicao dos retangulos transparentes
    image(opp,pox[i]-27,poy[i]-45);
 }
}

//======================FUNCAO MOVE OPONENTE=============================
// movimenta os oponentes e modifica variaveis a partir desta funcao
void moveOponente(){
  for (int i = 0; i < 2; i++) {
    
    int p= int(random(0,3)); // variavel local que pode assumir, randomicamente, tres valores: 0, 1 e 2
                             // Cada valor corresponde a uma "pista" no jogo
                             // 0 e´ a pista da esquerda, 1 a do meio e 2 a da direita 
    poy[i] += incY; //incrementa a posicao y do oponente
    
    // Quando os oponente somem na parte inferior da tela ocorrem as seguintes coisas:
    if (poy[i] >= 445) {
      poy[i] = -45; // a posicao y retorna ao valor inicial acima da tela
      pox[i] = 40 +(p*55); // a posicao x muda, randomicamente, para um dos tres valores aneriores
      voltas += 1; // a quantidade de voltas aumenta em 1
      slowBar +=8; // a barra slow motion aumenta de tamanho
      
      //nota: quando os dois oponentes tem o mesmo valor, eles se sobrepoem, parecendo que ha´ somente um oponente
      
      // A barra consegue atingir um certo limite, quando o faz
      // ela muda de cor (fica verde) e pode ser ativa para entrar no modo slow motion (ready=1)
      if (slowBar>92){              
        slowBar=92;
        ready=1;
        colorGreen = 255;
      }
      // Se as voltas atingirem certo valor, acontece o seguinte:
      if (voltas ==10){
        voltas =0; // "voltas" retorna ao valor 0 para poder ocorrer o loop novamente
        level +=1; // aumenta o nivel de dificuldade
        vida += 1; // o jogador ganha uma vida
        frame =40 + 10*level; // atualiza o valor do frame para aumentar a velocidade, portanto, a dificuldade do jogo
      }
    }
  }
}

//======================FUNCAO SETUP=============================
void setup(){
  
  // carrega as imagens dos carros oponentes e do jogador e suas respectivas mascaras
  car = loadImage ("car.png");
  carmask=loadImage ("carmask.png");
  opp = loadImage ("opp.png");
  oppmask = loadImage ("oppmask.png");
  
  // aplica a mascara nas imagens dos carros
  car.mask(carmask);   
  opp.mask(oppmask);
  
  // valor inicial para as coordenadas dos carros oponentes  
  for (int i = 0; i < 2; i++) {
    pox[i] = int(40);
    poy[i] = int(-45);
  }

  //tamanho da tela; cor de fundo; sem borda nas formas desenhadas
  size(310,400);
  background(0);
  noStroke();
  
  // carrega a fonte; atribui tamanho de 14 pt ao texto
  font = loadFont("Pixelation-48.vlw"); 
  textFont(font, 14);
  
  vida=3; // numero inicial de vidas
  incY=5; // incremento de y dos carros dos oponente. nota: essa variavel poe os carros
          // em movimento, mas nao esta´ relacionada a velocidade deles
  frame=40; // valor inicial do "frame"
  frameRate(frame); // taxa de frames por segundo, quanto maior for o valor de "frame" maio e´ a taxa, portanto
                    // o frameRate e´ o responsavel pela velocidade dos carros oponentes
  voltas = 0; // valor inicial de voltas
  level = 1; //valor inicial do nivel
  p = 1; // valor inicial da condicao p
  slowBar=0; // tamanho inicial da barra slowmotion
  ready=0; // como a barra esta´ vazia, o ready tem valor inicial de 0
  alfa=255; // como o jogo nao inicia no modo slowmotion, o alfa eh 100%
  colorGreen=0; // como a barra esta´ vazia, a cor da barra e´ vermelha e nao verde

  // o jogo comeca pela tela inicial, sendo que todas as outras sessoes iniciam desativadas
  inicio=true;
  jogo = false;
  crash=false;
  gameOver = false;
  slowMotion=false;
  
  // suaviza as formas
  smooth();
}

//======================FUNCAO DRAW=============================  
void draw(){
  
  //======================BOOLEAN INICIO=============================
  // tela inicial do jogo
  if (inicio ==true) {
    // desenha o fundo azul; exibe a imagem do carro do jogador
    background(0,0,110);
    image(car,220,220,80,140);
    
    // escreve nome do jogo
    textFont(font,30);
    fill(0);
    text("super race", 33,73);
    fill(255);
    text("super race", 30,70);
    textFont(font,10);
    fill(0);
    text("1989",243,86);
    fill(255);
    text("1989",241,84);
    
    // escreve instrucoes em preto para dar sensacao de sombreado
    textFont(font,12);
    fill(0);  
    text("Instructions:",12,232);
    text("Use the arrow keys",12,257);
    text("to move the car.",12,272);
    text("press 's' to activate",12,287);
    text("the slow motion mode",12,302);
    text("when it's ready.",12,317);   
    fill(0);
    
    // escreve mensagem
    text("Press any key to Start", 52, 162);
    fill(255);
    text("Press any key to Start", 50, 160);
  
    // escreve instrucoes em branco
    text("Instructions:",10,230);
    text("Use the arrow keys",10,255);
    text("to move the car.",10,270);
    text("press 's' to activate",10,285);
    text("the slow motion mode",10,300);
    text("when it's ready.",10,315);  
  
    // quando qualquer botao e´ pressionado, a tela de inicio e´
    // substituida pelo sessao do jogo
    if(keyPressed){
      inicio = false;
      jogo=true;
    }
  }

  //======================BOOLEAN JOGO=============================  
  // Aqui o jogo acontece
  if (jogo == true){
    
    // atualiza o valor do frameRate e inicializa as funcoes
    frameRate(frame);
    desenhaFundo();
    desenhaOponente();
    moveOponente();
    desenhaCarro();
    desenhaSlowBar();
 
    for(int i=0;i<2;i++){
      
      // Faz o calculo da distancia dos carros para ver se ha colisao
      // o calculo consiste na diferenca dos centro dos retangulos transparentes
      // se o resultado for menor que a dstancia dos carros na iminencia da batida,
      // entao ocorre as seguintes coisas:
      if( dist(px,py,pox[i],poy[i]) < 90 && int(px-pox[i])==0 ){
        vida -= 1; // subtrai em 1 a vida do jogador
        voltas = 0; // as voltas voltam para o valor zero, para comecar o nivel novamente
       
        // Se a vida do jogador, apos a batida, ainda for maior do que 0, entao ele e´ transferido para a tela "crash"
        if (vida!=0){
          jogo=false;
          crash=true;
        }
      
      // apos a batida, os valores das coordenadas dos carros oponentes retornam aos valores iniciais
      for (int j = 0; j < 2; j++) {
        pox[j] = int(40);
        poy[j] = int(-45);   
      }
      }
    }
    // Se apos a batida, o jogador tiver vida 0, ele e´ transferido para a tela de game over
    if (vida==0){
      jogo = false;
      gameOver = true;
    }
    
    // Faz o teste para ver se a barra do slow motion esta´ cheia, se tiver:
    if(ready==1){
      // o texto ready aparece abaixo da barra
      fill(0);
      text("ready !",202,337);
      fill(245);
      text("ready !",200,335);
      
      // se 's' e´ pressionado, entao o jogo fica no modo slow motion
      if(keyPressed){
        if (key == 's' || key == 'S'){
          slowMotion=true;
        }  
      }
    }  
  }

  //======================BOOLEAN SLOW MOTION=============================    
  // Essa sessao e´ ativada quando o jogo esta´ no modo slow motion
  if(slowMotion==true){
    
    alfa = 20; // o alpha do fundo muda, para criar a sensasao de movimento nos carros
    frame = 40; // o frame diminui, portanto a velocidade dos carros diminuem
    slowBar -= 1; // a barra diminui progressivamente
    colorGreen=0; // a cor da barra muda para vermelho
    
    // Faz o teste para ver se a barra diminuiu por completo, se sim:
    if( slowBar <0){
      ready=0; // o modo slowmotion nao pode ser utilizado
      colorGreen=0; // a barra fica vermelha
      slowBar=0; // o tamanho da barra e´ 0
      alfa =255; // alpha muda para 100%, retirando o efeito de movimento
      frame=40 +10*level; // volta a velocidade para antes do modo slow
      slowMotion=false; // sai do modo slow motion
    }
  }

  //======================BOOLEAN CRASH=============================  
  // tela aparece quando o carro bate e a vida do jogador e´ diferente de zero
  if (crash == true){
    p=0; // condicao e´ zero, portanto o jogador nao tem controle sobre o carro
    incY=0; // os carros oponentes param
    
    // escreve mensagem
    textFont(font,20);
    text("CRASH!!!",20,180);
    textFont(font,14);
    fill(0);
    text("Press 'a' to Continue", 22, 202);
    fill(255);
    text("Press 'a' to Continue", 20, 200);
   
    // quando o jogador presiona a tecla 'a' ou 'A', ocorre:
    if(keyPressed){
      if (key == 'a'|| key == 'A'){
        delay(150);
        ready=0; // o modo nao pode ser ativo imediatamente
        colorGreen=0; // a barra fica vermelha, se cheia
        alfa=255; // alpha fica 100%
        px=95; // automaticamente muda a posicao do carro do jogador para a "pista" do meio
        p=1; // libera o teclado
        incY=5; // inicia o movimento dos carros oponentes
        
        //volta a sessao do jogo
        crash=false;
        jogo=true;  
      }  
    }
  }

  //======================BOOLEAN GAME OVER=============================  
  // tela aparece quando o carro bate e a vida do jogador e´ igual a zero
  if (gameOver == true){
    p=0; // bloqueia o teclado
    incY=0; // para os carros oponentes
    
    //escreve mensagem
    fill(255,0,0,3);
    rectMode(CENTER);
    rect(155,200,310,400);
    fill(255);
    textFont(font,20);
    text("GAME OVER!",20,180);
    textFont(font,14);
    text("Press Enter to Restart", 20, 200);
    
    // quando o enter e´ apertado, a funcao setup e´ iniciada novamente,
    // iniciando o jogo novamente desde a tela inicial, como se fosse um restar
    if(keyPressed){
      if (key == ENTER|| key == RETURN){
        setup();
        delay(300);
      }
    }
  }
}


